apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ etherpad_name }}
  name: {{ etherpad_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ etherpad_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ etherpad_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ etherpad_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ etherpad_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ etherpad_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ etherpad_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% if etherpad_db_type in [ 'mariadb', 'mysql', 'postgres', 'percona' ] %}
      initContainers:
      - command:
        - sh
        - -c
        - |
            sed -e "s|DB_USER_PLACEHOLDER|$DB_USER|" \
                -e "s|DB_PASS_PLACEHOLDER|$DB_PASS|" \
                -e "s|DB_HOST_PLACEHOLDER|$DB_HOST|" \
                -e "s|DB_PORT_PLACEHOLDER|$DB_PORT|" \
                -e "s|DB_NAME_PLACEHOLDER|$DB_NAME|" \
                /settings.json \
                >/opt/shared-init/settings.json
        env:
        - name: DB_USER
{% if etherpad_db_type == 'postgres' %}
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ethpg_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ethpg_name }}
        - name: DB_HOST
          value: {{ ethpg_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ethpg_name }}
        - name: DB_PORT
          value: "5432"
{% elif etherpad_db_type == 'percona' %}
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ethpc_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ethpc_name }}
        - name: DB_HOST
          value: {{ ethpc_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ethpc_name }}
        - name: DB_PORT
          value: "3306"
{% elif etherpad_db_type in [ 'mysql', 'mariadb' ] %}
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ethms_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ethms_name }}
        - name: DB_HOST
          value: {{ ethms_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ethms_name }}
{% else %}
        - name: DB_PASS
          value: ""
        - name: DB_HOST
          value: ""
        - name: DB_PORT
          value: ""
        - name: DB_NAME
          value: ""
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: init-etherpad-settings
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /opt/shared-init
          name: shared-init
        - mountPath: /settings.json
          name: conf
          subPath: settings.json
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ etherpad_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ etherpad_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ etherpad_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: ETHERPAD_API_HOSTNAME
          value: {{ etherpad_fqdn }}
        - name: ETHERPAD_LLNG_BIND_PW
{% if do_ldap and do_lemon %}
          valueFrom:
            secretKeyRef:
              key: ssoapp-password
              name: {{ ldap_secret_name }}
        - name: LDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: LDAP_URL
          value: {{ ldaps_address }}
        - name: LEMON_PORTAL
          value: {{ lemon_portal }}
{% else %}
          value: ""
        - name: LDAP_BASE
          value: ""
        - name: LDAP_URL
          value: ""
        - name: LEMON_PORTAL
          value: ""
{% endif %}
        - name: NO_K8S_ENV
          value: pm2-is-stupid
        - name: NODE_ENV
          value: production
{% if (ldaps_address | default(False) and skip_ldap_verify | default(False)) or (do_lemon and skip_lemon_verify | default(False)) %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: '0'
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: USER_AGENT
          value: pong
{% if do_triggers == False or (opsimages | json_query("[?name=='etherpad'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='etherpad'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 12
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ etherpad_fqdn }}
            path: /robots.txt
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: etherpad
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ etherpad_fqdn }}
            path: /robots.txt
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ etherpad_cpu_limit }}"
            memory: "{{ etherpad_memory_limit }}"
          requests:
            cpu: "{{ etherpad_cpu_request }}"
            memory: "{{ etherpad_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or do_lemon or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /opt/app-root/src/APIKEY.txt
          name: apikey
          subPath: APIKEY.txt
        - mountPath: /opt/app-root/src/SESSIONKEY.txt
          name: apikey
          subPath: SESSIONKEY.txt
{% if etherpad_db_type in [ 'mariadb', 'mysql', 'postgres', 'percona' ] %}
        - mountPath: /opt/shared-init
          name: shared-init
{% else %}
        - mountPath: /opt/app-root/src/settings.json
          name: conf
          subPath: settings.json
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ etherpad_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: apikey
        secret:
          defaultMode: 420
          secretName: {{ etherpad_name }}
      - configMap:
          defaultMode: 420
          name: {{ etherpad_name }}
        name: conf
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if airbrake_host | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: airbrake-ca.crt
{% if errbit_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if etherpad_db_type in [ 'mariadb', 'mysql', 'postgres', 'percona' ] %}
      - emptyDir: {}
        name: shared-init
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='etherpad'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - etherpad
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='etherpad'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
